var tcm = {};

function cpmGetInfillCoeff(infill) {
}

window.wp.event_manager.addFilter( 'p3d.calculatePrintingCost', function  (total, product_info) {
	var material = jQuery('input[name=product_filament]:checked');
	var coating = jQuery('input[name=product_coating]:checked');
	var printer = jQuery('input[name=product_printer]:checked');
	var infill = jQuery('input[name=product_infill]:checked');
	var infill_value = infill.val();
	var postprocessings = jQuery('input[name^=product_postprocessing]:checked');


	if (typeof(material)=='undefined') return;
	if (typeof(printer)=='undefined') return;

	p3d.support_charges = 0;

	var printer_price_fields = ['', '1', '2', '3', '4'];
	var material_price_fields = ['', '1', '2'];
	var coating_price_fields = ['', '1'];
	var infill_price_fields = ['', '1'];
	var postprocessing_price_fields = ['', '1'];

	var material_cost = 0;
	var coating_cost = 0;
	var printing_cost = 0;
	var infill_cost = 0;
	var postprocessing_cost = 0;

	var material_pct = 0;
	var coating_pct = 0;
	var infill_pct = 0;
	var printing_pct = 0;
	var postprocessing_pct = 0;


	printing_volume=product_info['model']['material_volume'];

	var removed_material_volume = product_info['model']['box_volume']-printing_volume;
	var total_path = p3d.cut_path / 10;
//	var support_charges = 0;

//	if (p3d.price_debug_mode=='on') console.clear();
//console.log(product_info['model']);
	for (var p=0;p<material_price_fields.length;p++) {
		if ( !isNaN ( material.data('price'+material_price_fields[p]) ) ) {
			if ( material.data('price_type'+material_price_fields[p])=='cm3' ) {
				material_cost+=( printing_volume )*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" volume charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=='cm2' ) {
				material_cost += product_info['model']['surface_area'] * material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" surface area charges:", product_info['model']['surface_area'] * material.data('price'+material_price_fields[p]));

			}
			else if ( material.data('price_type'+material_price_fields[p])=="box_volume" ) {
				material_cost+=product_info['model']['box_volume']*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" box volume charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=="box_xy" ) {
				material_cost+=(product_info['model']['x_dim'] * product_info['model']['y_dim'])*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" box XY charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=="support_material_volume" && typeof(product_info['model']['support_material_volume'])!='undefined') {
				material_cost+=product_info['model']['support_material_volume']*material.data('price'+material_price_fields[p]);
				p3d.support_charges+=product_info['model']['support_material_volume']*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" support volume charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=="support_material_fixed" && typeof(product_info['model']['support_material_volume'])!='undefined' && product_info['model']['support_material_volume']>0) {
				material_cost+=material.data('price'+material_price_fields[p]);
				p3d.support_charges+=material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" support volume charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=="removed_material_volume" ) {
				material_cost+=removed_material_volume*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" removed volume charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=="total_path" ) {
				material_cost+=total_path*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" total path charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=='gram' ) {
				material_cost+=product_info['model']['weight']*material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" weight charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=='volumetric_weight' ) {
				var volumetric_weight_indicator = material.data('volumetric-weight-indicator');

				if (volumetric_weight_indicator!=0) {

					var volumetric_weight = product_info['model']['box_volume'] / volumetric_weight_indicator;
					var max_weight = Math.max(volumetric_weight, product_info['model']['weight']);
					material_cost+=max_weight*material.data('price'+material_price_fields[p]);
					//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" volumetric weight charges:", (max_weight*material.data('price'+material_price_fields[p])));
				}
			}
			else if ( material.data('price_type'+material_price_fields[p])=='fixed' ) {
				material_cost+=material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" fixed charges:", material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=='hour' ) {
				material_cost+=(parseFloat(p3d.print_time) / 3600) * material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" per hour charges:", (parseFloat(p3d.print_time) / 3600) * material.data('price'+material_price_fields[p]));
			}
			else if ( material.data('price_type'+material_price_fields[p])=='pct' ) {
				material_pct+=material.data('price'+material_price_fields[p]);
				//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" % charges:", material.data('price'+printer_price_fields[p]));
			}
		}
		else if ( material.data('price'+material_price_fields[p]).indexOf(':')>-1 ) {
	
			var material_volume_pricing_array = material.data('price'+material_price_fields[p]).split(';');

			for (var i = material_volume_pricing_array.length-1; i >= 0; i--) {
				var discount_rule = material_volume_pricing_array[i].split(':');
				if (discount_rule.length == 2) {
					var amount = parseFloat(discount_rule[0]);
					var price = parseFloat(discount_rule[1]);	

					if ( material.data('price_type'+material_price_fields[p])=='cm3' ) {
						if (printing_volume >= amount ) {
							material_cost += printing_volume * price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" volume charges by formula "+material.data('price'+material_price_fields[p])+":", printing_volume * price);
							break;
						}
					}
					else if ( material.data('price_type'+material_price_fields[p])=='cm2' ) {
						if (product_info['model']['surface_area'] >= amount) {
							material_cost += product_info['model']['surface_area'] * price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" surface area charges by formula "+material.data('price'+material_price_fields[p])+":", product_info['model']['surface_area'] * price);
							break;
						}
					}
					else if ( material.data('price_type'+material_price_fields[p])=='gram' ) {
						if (product_info['model']['weight'] >= amount)  {
							material_cost += product_info['model']['weight'] * price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" weight charges by formula "+material.data('price'+material_price_fields[p])+":", product_info['model']['weight'] * price);
							break;
						}
					}
					else if ( material.data('price_type'+material_price_fields[p])=='support_material_volume' && typeof(product_info['model']['support_material_volume'])!='undefined') {
						if (product_info['model']['support_material_volume'] >= amount)  {
							material_cost += product_info['model']['support_material_volume'] * price;
							p3d.support_charges += product_info['model']['support_material_volume'] * price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" support volume charges by formula "+material.data('price'+material_price_fields[p])+":", removed_material_volume * price);
							break;
						}
					}
					else if ( material.data('price_type'+material_price_fields[p])=='removed_material_volume' ) {
						if (removed_material_volume >= amount)  {
							material_cost += removed_material_volume * price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" removed volume charges by formula "+material.data('price'+material_price_fields[p])+":", removed_material_volume * price);
							break;
						}
					}
					else if ( material.data('price_type'+material_price_fields[p])=='total_path' ) {
						if (total_path >= amount)  {
							material_cost += total_path * price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" total path charges by formula "+material.data('price'+material_price_fields[p])+":", total_path * price);
							break;
						}
					}
					else if ( material.data('price_type'+material_price_fields[p])=='fixed' ) {
						if (printing_volume >= amount ) {
							material_cost += price;
							//p3dPriceDebug("Material '"+material.data('name')+"' Price Field "+p+" fixed charges by formula "+material.data('price'+material_price_fields[p])+":", price);
							break;
						}
					}
				}
			}
		}
	}
	var material_min_price = parseFloat(material.data('min_price'));
	if (material_cost < material_min_price) {
		material_cost = material_min_price;
		//p3dPriceDebug("Setting minimum material price:", material_min_price);
	}
	//p3dPriceDebug("Material Total Cost:", material_cost);
	for (var p=0;p<printer_price_fields.length;p++) {
//		if (typeof(printer.data('price'+printer_price_fields[p]))=='undefined') continue;
		if ( !isNaN ( printer.data('price'+printer_price_fields[p]) ) ) {

			if ( printer.data('price_type'+printer_price_fields[p])=="material_volume" ) {
				printing_cost+=printing_volume*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" volume charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="box_volume" ) {
				printing_cost+=product_info['model']['box_volume']*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" box volume charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="box_xy" ) {
				printing_cost+=(product_info['model']['x_dim'] * product_info['model']['y_dim'])*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" box XY charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="support_material_volume" && typeof(product_info['model']['support_material_volume'])!='undefined') {
				printing_cost+=product_info['model']['support_material_volume']*printer.data('price'+printer_price_fields[p]);
				p3d.support_charges+=product_info['model']['support_material_volume']*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" support volume charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="support_material_fixed" && typeof(product_info['model']['support_material_volume'])!='undefined' && product_info['model']['support_material_volume']>0) {
				printing_cost+=printer.data('price'+printer_price_fields[p]);
				p3d.support_charges+=printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" support volume charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="removed_material_volume" ) {
				printing_cost+=removed_material_volume*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" removed volume charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="total_path" ) {
				printing_cost+=total_path*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" total path charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="gram" ) {
				printing_cost+=product_info['model']['weight']*printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" weight charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="hour" ) {
				printing_cost += (parseFloat(p3d.print_time) / 3600) * printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" per hour charges:", (parseFloat(p3d.print_time) / 3600) * printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="fixed" ) {
				printing_cost += printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" fixed charges:", printer.data('price'+printer_price_fields[p]));
			}
			else if ( printer.data('price_type'+printer_price_fields[p])=="pct" ) {
				printing_pct += printer.data('price'+printer_price_fields[p]);
				//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" % charges:", printer.data('price'+printer_price_fields[p]));
			}
		}
		else if ( printer.data('price'+printer_price_fields[p]).indexOf(':')>-1 ) {
			var printer_volume_pricing_array = printer.data('price'+printer_price_fields[p]).split(';');
			for (var i = printer_volume_pricing_array.length-1; i >=0; i--) {
				var discount_rule = printer_volume_pricing_array[i].split(':');
				if (discount_rule.length == 2) {
					var amount = parseFloat(discount_rule[0]);
					var price = parseFloat(discount_rule[1]);	
					if ( printer.data('price_type'+printer_price_fields[p])=='material_volume' ) {
						if (printing_volume >= amount) {
							printing_cost += printing_volume * price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" volume charges by formula "+printer.data('price'+material_price_fields[p])+":", printing_volume * price);
							break;
						}
					}
					else if ( printer.data('price_type'+printer_price_fields[p])=='box_volume' ) {
						if (product_info['model']['box_volume'] >= amount) {
							printing_cost += product_info['model']['box_volume'] * price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" box volume charges by formula "+printer.data('price'+printer_price_fields[p])+":", product_info['model']['box_volume'] * price);
							break;
						}
					}
					else if ( printer.data('price_type'+printer_price_fields[p])=='support_material_volume' && typeof(product_info['model']['support_material_volume'])!='undefined') {
						if (removed_material_volume >= amount) {
							printing_cost += product_info['model']['support_material_volume'] * price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" support volume charges by formula "+printer.data('price'+printer_price_fields[p])+":", removed_material_volume * price);
							break;
						}
					}
					else if ( printer.data('price_type'+printer_price_fields[p])=='removed_material_volume' ) {
						if (removed_material_volume >= amount) {
							printing_cost += removed_material_volume * price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" removed volume charges by formula "+printer.data('price'+printer_price_fields[p])+":", removed_material_volume * price);
							break;
						}
					}
					else if ( printer.data('price_type'+printer_price_fields[p])=='total_path' ) {
						if (total_path >= amount) {
							printing_cost += total_path * price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" total path charges by formula "+printer.data('price'+printer_price_fields[p])+":", removed_material_volume * price);
							break;
						}
					}
					else if ( printer.data('price_type'+printer_price_fields[p])=='gram' ) {
						if (product_info['model']['weight'] >= amount) {
							printing_cost += product_info['model']['weight'] * price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" weight charges by formula "+printer.data('price'+printer_price_fields[p])+":", product_info['model']['weight'] * price);
							break;
						}
					}
					else if ( printer.data('price_type'+printer_price_fields[p])=='fixed' ) {
						if (printing_volume >= amount) {
							printing_cost += price;
							//p3dPriceDebug("Printer '"+printer.data('name')+"' Price Field "+p+" fixed charges by formula "+printer.data('price'+printer_price_fields[p])+":", price);
							break;
						}
					}
				}
			}
		}

	}


	if (p3d.print_time>0) {
		var print_hours = p3d.print_time/3600;
		var printer_energy_hourly_cost = printer.data('printer_energy_hourly_cost');
		var printer_depreciation_hourly_cost = printer.data('printer_depreciation_hourly_cost');
		var printer_repair_hourly_cost = printer.data('printer_repair_hourly_cost');
		printing_cost += print_hours * printer_energy_hourly_cost;
		//p3dPriceDebug("Printer Energy Hourly Cost:", print_hours * printer_energy_hourly_cost);
		printing_cost += print_hours * printer_depreciation_hourly_cost;
		//p3dPriceDebug("Printer Depreciation Cost:", print_hours * printer_depreciation_hourly_cost);
		printing_cost += print_hours * printer_repair_hourly_cost;
		//p3dPriceDebug("Printer Repair Cost:", print_hours * printer_repair_hourly_cost);
	}

	var printer_min_price = parseFloat(printer.data('min_price'));
	if (printing_cost < printer_min_price) {
		printing_cost = printer_min_price;
		//p3dPriceDebug("Setting minimum printer price:", printer_min_price);
	}

	//p3dPriceDebug("Printer Total Cost:", printing_cost);

	for (var p=0;p<coating_price_fields.length;p++) {
		if (typeof(coating.data('price'+coating_price_fields[p]))!=='undefined') {
			if ( !isNaN ( coating.data('price'+coating_price_fields[p]) ) ) {
				if ( coating.data('price_type'+coating_price_fields[p])=='cm2' ) {
					coating_cost += product_info['model']['surface_area'] * coating.data('price'+coating_price_fields[p]);
					//p3dPriceDebug("Coating '"+coating.data('name')+"' Price Field "+p+" surface area charges:", product_info['model']['surface_area'] * coating.data('price'+coating_price_fields[p]));
				}
				else if ( coating.data('price_type'+coating_price_fields[p])=='fixed' ) {
					coating_cost += coating.data('price'+coating_price_fields[p]);
					//p3dPriceDebug("Coating '"+coating.data('name')+"' Price Field "+p+" fixed charges:", coating.data('price'+coating_price_fields[p]));
				}
				else if ( coating.data('price_type'+coating_price_fields[p])=='pct' ) {
					coating_pct += coating.data('price'+coating_price_fields[p]);
					//p3dPriceDebug("Coating '"+coating.data('name')+"' Price Field "+p+" % charges:", coating.data('price'+coating_price_fields[p]));
				}
			}
			else if ( coating.data('price'+coating_price_fields[p]).indexOf(':')>-1 ) {
				var surface_area_pricing_array = coating.data('price'+coating_price_fields[p]).split(';');
				for (var i = surface_area_pricing_array.length-1; i >= 0; i--) {
					var discount_rule = surface_area_pricing_array[i].split(':');
					if (discount_rule.length == 2) {
						var amount = parseFloat(discount_rule[0]);
						var price = parseFloat(discount_rule[1]);	
						if ( coating.data('price_type'+coating_price_fields[p])=='cm2' ) {
							if (product_info['model']['surface_area'] >= amount) {
								coating_cost += product_info['model']['surface_area'] * price;
								//p3dPriceDebug("Coating '"+coating.data('name')+"' Price Field "+p+" surface area charges by formula "+coating.data('price'+coating_price_fields[p])+":", product_info['model']['surface_area'] * price);
								break;
							}
						}
						else if ( coating.data('price_type'+coating_price_fields[p])=='fixed' ) {
							if (product_info['model']['surface_area'] >= amount) {
								coating_cost += price;
								//p3dPriceDebug("Coating '"+coating.data('name')+"' Price Field "+p+" fixed charges by formula "+coating.data('price'+coating_price_fields[p])+":", price);
								break;
							}
						}
					}
				}
			}
		}
	}

	var coating_min_price = parseFloat(coating.data('min_price'));
	if (coating_cost < coating_min_price) {
		coating_cost = coating_min_price;
		//p3dPriceDebug("Setting minimum coating price:", coating_min_price);
	}

	postprocessings.each(function(){
		var postprocessing = jQuery(this);
		for (var p=0;p<postprocessing_price_fields.length;p++) {
			if (typeof(postprocessing.data('price'+postprocessing_price_fields[p]))!=='undefined') {
				if ( !isNaN ( postprocessing.data('price'+postprocessing_price_fields[p]) ) ) {

					var is_support = parseInt(postprocessing.data('is_support'));
					if (is_support && p3d.analysed_support_volume==0) continue;

					if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='cm2' ) {
						postprocessing_cost += product_info['model']['surface_area'] * postprocessing.data('price'+postprocessing_price_fields[p]);
						p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" surface area charges:", product_info['model']['surface_area'] * postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="material_volume" ) {
						postprocessing_cost+=printing_volume*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" volume charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="box_volume" ) {
						postprocessing_cost+=product_info['model']['box_volume']*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" box volume charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="box_xy" ) {
						postprocessing_cost+=(product_info['model']['x_dim'] * product_info['model']['y_dim'])*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" box XY charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="support_material_volume" && typeof(product_info['model']['support_material_volume'])!='undefined') {
						postprocessing_cost+=product_info['model']['support_material_volume']*postprocessing.data('price'+postprocessing_price_fields[p]);
						p3d.support_charges+=product_info['model']['support_material_volume']*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" support volume charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="support_material_fixed" && typeof(product_info['model']['support_material_volume'])!='undefined' && product_info['model']['support_material_volume']>0) {
						postprocessing_cost+=postprocessing.data('price'+postprocessing_price_fields[p]);
						p3d.support_charges+=postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" support volume charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="removed_material_volume" ) {
						postprocessing_cost+=removed_material_volume*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" removed volume charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="total_path" ) {
						postprocessing_cost+=total_path*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" total path charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="gram" ) {
						postprocessing_cost+=product_info['model']['weight']*postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" weight charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=="hour" ) {
						postprocessing_cost += (parseFloat(p3d.print_time) / 3600) * postprocessing.data('price'+postprocessing_price_fields[p]);
						//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" per hour charges:", (parseFloat(p3d.print_time) / 3600) * postprocessing.data('price'+postprocessing_price_fields[p]));
					}

					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='fixed' ) {
						postprocessing_cost += postprocessing.data('price'+postprocessing_price_fields[p]);
						p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" fixed charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
					else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='pct' ) {
						postprocessing_pct += postprocessing.data('price'+postprocessing_price_fields[p]);
						p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" % charges:", postprocessing.data('price'+postprocessing_price_fields[p]));
					}
				}
				else if ( postprocessing.data('price'+postprocessing_price_fields[p]).indexOf(':')>-1 ) {
					var surface_area_pricing_array = postprocessing.data('price'+postprocessing_price_fields[p]).split(';');
					for (var i = surface_area_pricing_array.length-1; i >= 0; i--) {
						var discount_rule = surface_area_pricing_array[i].split(':');
						if (discount_rule.length == 2) {
							var amount = parseFloat(discount_rule[0]);
							var price = parseFloat(discount_rule[1]);	
							if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='cm2' ) {
								if (product_info['model']['surface_area'] >= amount) {
									postprocessing_cost += product_info['model']['surface_area'] * price;
									p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" surface area charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", product_info['model']['surface_area'] * price);
									break;
								}
							}
							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='material_volume' ) {
								if (printing_volume >= amount) {
									postprocessing_cost += printing_volume * price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" volume charges by formula "+postprocessing.data('price'+material_price_fields[p])+":", printing_volume * price);
									break;
								}
							}
							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='box_volume' ) {
								if (product_info['model']['box_volume'] >= amount) {
									postprocessing_cost += product_info['model']['box_volume'] * price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" box volume charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", product_info['model']['box_volume'] * price);
									break;
								}
							}
							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='support_material_volume' && typeof(product_info['model']['support_material_volume'])!='undefined') {
								if (removed_material_volume >= amount) {
									postprocessing_cost += product_info['model']['support_material_volume'] * price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" support volume charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", removed_material_volume * price);
									break;
								}
							}
							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='removed_material_volume' ) {
								if (removed_material_volume >= amount) {
									postprocessing_cost += removed_material_volume * price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" removed volume charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", removed_material_volume * price);
									break;
								}
							}
							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='total_path' ) {
								if (total_path >= amount) {
									postprocessing_cost += total_path * price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" total path charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", removed_material_volume * price);
									break;
								}
							}
							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='gram' ) {
								if (product_info['model']['weight'] >= amount) {
									postprocessing_cost += product_info['model']['weight'] * price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" weight charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", product_info['model']['weight'] * price);
									break;
								}
							}

							else if ( postprocessing.data('price_type'+postprocessing_price_fields[p])=='fixed' ) {
								if (product_info['model']['surface_area'] >= amount) {
									postprocessing_cost += price;
									//p3dPriceDebug("Postprocessing '"+postprocessing.data('name')+"' Price Field "+p+" fixed charges by formula "+postprocessing.data('price'+postprocessing_price_fields[p])+":", price);
									break;
								}
							}
						}
					}
				}
			}
		}

		var postprocessing_min_price = parseFloat(postprocessing.data('min_price'));
		if (postprocessing_cost < postprocessing_min_price) {
			postprocessing_cost += postprocessing_min_price;
			p3dPriceDebug("Setting minimum postprocessing '"+postprocessing.data('name')+"' price:", postprocessing_min_price);
		}
	})


	for (var p=0;p<infill_price_fields.length;p++) {
//console.log(infill.data('price'+infill_price_fields[p]));
		if (typeof(infill.data('price'+infill_price_fields[p]))!=='undefined') {
			if ( !isNaN ( infill.data('price'+infill_price_fields[p]) ) ) {

				if ( infill.data('price_type'+infill_price_fields[p])=='fixed' ) {
					infill_cost += infill.data('price'+infill_price_fields[p]);
					//p3dPriceDebug("Infill '"+infill.data('name')+"' Price Field "+p+" fixed charges:", infill.data('price'+infill_price_fields[p]));
				}
				else if ( infill.data('price_type'+infill_price_fields[p])=='pct' ) {
					infill_pct += infill.data('price'+infill_price_fields[p]);
					//p3dPriceDebug("Infill '"+infill.data('name')+"' Price Field "+p+" % charges:", infill.data('price'+infill_price_fields[p]));
				}
				else if ( infill.data('price_type'+infill_price_fields[p])=='pct_mat' ) {
					material_cost+=(material_cost/100)*infill.data('price'+infill_price_fields[p]);
					//p3dPriceDebug("Infill '"+infill.data('name')+"' Price Field "+p+" material charges:", (material_cost/100)*infill.data('price'+infill_price_fields[p]));
				}
			}
		}
	}


	jQuery( ".woo_attribute" ).each(function() {
		var attr_price=parseFloat(jQuery(this).find('option:selected').data('price'));
		if (isNaN(attr_price)) attr_price = 0;
		var attr_price_type=jQuery(this).find('option:selected').data('price-type');
		var attr_pct_type=jQuery(this).find('option:selected').data('pct-type');

		if (typeof(attr_pct_type)!=='undefined' && attr_price_type=='pct') {
			if (attr_pct_type=='printer') {	
				printing_cost+=(printing_cost/100)*attr_price
				//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' +% to printer cost:", (printing_cost/100)*attr_price);
			}
			else if (attr_pct_type=='material') {	
				material_cost+=(material_cost/100)*attr_price
				//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' +% to material cost:", (material_cost/100)*attr_price);
			}
			else if (attr_pct_type=='coating') {
				coating_cost+=(coating_cost/100)*attr_price
				//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' +% to coating cost:", (coating_cost/100)*attr_price);

			}
		}

	})

	printing_cost = printing_cost || 0;
	material_cost = material_cost || 0;
	coating_cost = coating_cost || 0;
	infill_cost = infill_cost || 0;
	postprocessing_cost = postprocessing_cost || 0;

	printing_pct = printing_pct || 0;
	material_pct = material_pct || 0;
	coating_pct = coating_pct || 0;
	infill_pct = infill_pct || 0;
	postprocessing_pct = postprocessing_pct || 0;

	var subtotal=printing_cost+material_cost+coating_cost+infill_cost+postprocessing_cost;
	var total=printing_cost+material_cost+coating_cost+infill_cost+postprocessing_cost;


	total+=(total/100)*(printing_pct + material_pct + coating_pct + infill_pct + postprocessing_pct);



	var attr_total = 0;
	jQuery( ".woo_attribute" ).each(function() {
		var attr_price=parseFloat(jQuery(this).find('option:selected').data('price'));
		if (isNaN(attr_price)) attr_price = 0;
		var attr_price_type=jQuery(this).find('option:selected').data('price-type');
		var attr_pct_type=jQuery(this).find('option:selected').data('pct-type');
		var flat_type=jQuery(this).find('option:selected').data('flat-type');

		if (attr_price_type=='flat') {
			if (flat_type=='support_material_amount' && p3d.analysed_support_volume>0) {
				var support_price = attr_price * (p3d.analysed_support_volume/1000)
				total+=support_price;
				attr_total+=support_price;
				//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' support material charges per cm3:", support_price);
			}
			else if (flat_type=='support_material_flat' && p3d.analysed_support_volume>0) {
				total+=attr_price;
				//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' support material fixed charges:", attr_price);
				attr_total+=attr_price;
			}
			else {
				total+=attr_price;
				//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' fixed charges:", attr_price);
				attr_total+=attr_price;
			}
		}
		else if (typeof(attr_pct_type)!=='undefined' && attr_price_type=='pct' && attr_pct_type=='total') {
			total+=(total/100)*attr_price;
			//p3dPriceDebug("Custom attribute '"+jQuery(this).val()+"' % charges:", attr_price);
			attr_total+=(total/100)*attr_price;
		}
	})

	//p3dPriceDebug("Total Custom Attributes Cost:", attr_total);

	if (p3d.minimum_price_type=='starting_price')  {
		total = total + parseFloat(p3d.min_price);
		//p3dPriceDebug("Adding Starting Price:", parseFloat(p3d.min_price));
	}
	else if (p3d.minimum_price_type=='minimum_price') {
		if (total < p3d.min_price) {
			total = parseFloat(p3d.min_price) + attr_total;
			//p3dPriceDebug("Minimum Price:", parseFloat(p3d.min_price));
		}
	}

	if (p3d.file_url && p3d.file_url.length>0 && p3d.product_price_type && p3d.product_price_type=='fixed') {
		//p3dPriceDebug("Minimum Price:", parseFloat(p3d.min_price));
		total = parseFloat(p3d.min_price) + attr_total;
	}

	total = parseFloat(total);

	//DO SOMETHING WITH THE TOTAL HERE

	return total;
}, 5)